from pymclevel import TAG_Byte, TAG_Short, TAG_Int, TAG_Compound, TAG_List, TAG_String, TAG_Double, TAG_Float
from pymclevel import MCSchematic
from pymclevel.materials import alphaMaterials
import mcplatform

displayName = "Moving Block Creator"

inputs = (
    ("max height",100),
    )

def perform(level, box, options):
    size = 0
    xpositive = 0
    ypositive = 0
    zpositive = 0
    blocktotal = 1
    block = 1
    widthblock = 0
    commandvariable = "setblock ~ ~1 ~-1 152"
    maxheight = options["max height"]
    if maxheight < 2:
        raise Exception("the hight needs to be minimal 2")
    if maxheight > 256:
        raise Exception("the hight can be maximal 256")
    if (box.maxx-box.minx) > 1:
        size += 1
        if level.blockAt(box.minx,box.miny,box.minz) != 0:
            xpositive = 1
        else:
            xpositive = -1
    if (box.maxy-box.miny) > 1:
        size += 1
        if level.blockAt(box.minx,box.miny,box.minz) != 0:
            ypositive = 1
        else:
            ypositive = -1
    if (box.maxz-box.minz) > 1:
        size += 1
        if level.blockAt(box.minx,box.miny,box.minz) != 0:
            zpositive = 1
        else:
            zpositive = -1
    if size != 1:
        raise Exception("The selected area is too big")
    if level.blockAt(box.minx,box.miny,box.minz) != 0:
        positive = 1
    else:
        positive = -1
    blocks = 33*((box.maxx-box.minx)*(box.maxy-box.miny)*(box.maxz-box.minz)-1)
    width = (blocks - blocks % (maxheight+1)) / (maxheight+1) * 3 + 3
    if blocks < maxheight:
        height = blocks+1
    else:
        height = maxheight
    if width == 3:
        blocktotal = 1
    schematic = MCSchematic((width,height,2), mats=level.materials)
    if positive == 1:
        x = 0.5+box.minx
        y = 0.5+box.miny
        z = 0.5+box.minz
        ID = level.blockAt(box.minx,box.miny,box.minz)
    else:
        x = box.maxx-0.5
        y = box.maxy-0.5
        z = box.maxz-0.5
        ID = level.blockAt(box.maxx-1,box.maxy-1,box.maxz-1)
    command = "setblock x y z 0"
    command = command.replace("x",str(x))
    command = command.replace("y",str(y))
    command = command.replace("z",str(z))
    inputcommand = TAG_Compound()
    inputcommand["id"] = TAG_String("Control")
    inputcommand["x"] = TAG_Int(1)
    inputcommand["y"] = TAG_Int(0)
    inputcommand["z"] = TAG_Int(0)
    inputcommand["SuccessCount"] = TAG_Int(0)
    inputcommand["Command"] = TAG_String(command)
    schematic.setBlockAt(1,0,0,137)
    schematic.setBlockDataAt(1,0,0,0)
    schematic.TileEntities.append(inputcommand)
    xv = 0+xpositive*0.03125
    yv = 0.04+ypositive*0.03125
    zv = 0+zpositive*0.03125
    while blocktotal <= blocks:
        if block < maxheight:
            x = x+xpositive*0.03
            y = y+ypositive*0.03
            z = z+zpositive*0.03
            if block == maxheight-1:
                commandvariable = "setblock ~3 ~height ~-1 152"
                commandvariable = commandvariable.replace("height",str(-maxheight+1))
            if blocktotal % 33 == 0:
                if int(x) < 0:
                    x = int(x)-0.5
                else: 
                    x = int(x)+0.5
                y = int(y)+0.5
                if int(z) < 0:
                    z = int(z)-0.5
                else:
                    z = int(z)+0.5
            if blocktotal == blocks:
                if int(x) < 0:
                    x -= 1
                if int(z) < 0:
                    z -= 1
                command = "setblock x y z Id"
                command = command.replace("x",str(int(x)))
                command = command.replace("y",str(int(y)))
                command = command.replace("z",str(int(z)))
                command = command.replace("Id",str(int(ID)))
                inputcommand = TAG_Compound()
                inputcommand["id"] = TAG_String("Control")
                inputcommand["x"] = TAG_Int(widthblock)
                inputcommand["y"] = TAG_Int(block)
                inputcommand["z"] = TAG_Int(0)
                inputcommand["SuccessCount"] = TAG_Int(0)
                inputcommand["Command"] = TAG_String(command)
                schematic.setBlockAt(widthblock,block,0,137)
                schematic.setBlockDataAt(widthblock,block,0,0)
                schematic.TileEntities.append(inputcommand)
            else:
                command = "summon FallingSand x  y  z  {TileID:Id,Motion:[xv,yv,zv]}"
                command = command.replace("x ",str(x))
                command = command.replace("y ",str(y))
                command = command.replace("z ",str(z))
                command = command.replace("xv",str(xv))
                command = command.replace("yv",str(yv))
                command = command.replace("zv",str(zv))
                command = command.replace("Id",str(ID))
                inputcommand = TAG_Compound()
                inputcommand["id"] = TAG_String("Control")
                inputcommand["x"] = TAG_Int(widthblock)
                inputcommand["y"] = TAG_Int(block)
                inputcommand["z"] = TAG_Int(0)
                inputcommand["SuccessCount"] = TAG_Int(0)
                inputcommand["Command"] = TAG_String(command)
                schematic.setBlockAt(widthblock,block,0,137)
                schematic.setBlockDataAt(widthblock,block,0,0)
                schematic.TileEntities.append(inputcommand)
                inputcommand = TAG_Compound()
                inputcommand["id"] = TAG_String("Control")
                inputcommand["x"] = TAG_Int(1+widthblock)
                inputcommand["y"] = TAG_Int(block)
                inputcommand["z"] = TAG_Int(1)
                inputcommand["SuccessCount"] = TAG_Int(0)
                inputcommand["Command"] = TAG_String(commandvariable)
                schematic.setBlockAt(1+widthblock,block,1,137)
                schematic.setBlockDataAt(1+widthblock,block,1,0)
                schematic.TileEntities.append(inputcommand)
                commandvariable = "setblock ~ ~1 ~-1 152"
            command = "setblock ~-1 ~ ~ 0"
            inputcommand = TAG_Compound()
            inputcommand["id"] = TAG_String("Control")
            inputcommand["x"] = TAG_Int(2+widthblock)
            inputcommand["y"] = TAG_Int(block)
            inputcommand["z"] = TAG_Int(0)
            inputcommand["SuccessCount"] = TAG_Int(0)
            inputcommand["Command"] = TAG_String(command)
            schematic.setBlockAt(2+widthblock,block,0,137)
            schematic.setBlockDataAt(2+widthblock,block,0,0)
            schematic.TileEntities.append(inputcommand)   
            block += 1
            blocktotal += 1
        else:
            block = 0
            widthblock += 3

        
    schematic_file = mcplatform.askSaveFile(mcplatform.lastSchematicsDir or mcplatform.schematicsDir, "Save Schematic As...", "", "Schematic\0*.schematic\0\0", ".schematic")
    if schematic_file == None:
	print "input a filename, what are you, stupid?!"
        return
    schematic.saveToFile(schematic_file)
